dnl Signal class for inter-thread communication with argument support.
dnl
dnl Copyright 2004 Christer Palm <palm@nogui.se>
dnl
dnl Based on GtkmmDispatcher:
dnl Copyright 2000 Andreas Rottmannn <rottmann@users.sourceforge.net>
dnl Copyright 2004 Martin Schulze <mschulze@cvs.gnome.org>
dnl 
dnl This library is free software; you can redistribute it and/or 
dnl modify it under the terms of the GNU Lesser General Public 
dnl License as published by the Free Software Foundation; either 
dnl version 2.1 of the License, or (at your option) any later version. 
dnl 
dnl This library is distributed in the hope that it will be useful, 
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of 
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
dnl Lesser General Public License for more details. 
dnl 
dnl You should have received a copy of the GNU Lesser General Public 
dnl License along with this library; if not, write to the Free Software 
dnl Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
dnl
divert(-1)

include(template.macros.m4)

define([DISPATCHER_N],[dnl
ifelse($1, $2,[dnl
/** Dispatcher
 */
template <LOOP(class T_arg%1 = internal::nil, $1)>],[dnl
/** Template specialization for Dispatcher with $1 args
 */
template <LOOP(class T_arg%1, $1)>])
class Dispatcher ifelse($1, $2,,[<LOOP(T_arg%1, $1)>]) :
    private internal::DispatcherBase,
    public sigc::signal<LIST(void, LOOP(T_arg%1, $1))>
{
    public:
        typedef sigc::signal<LIST(void, LOOP(T_arg%1, $1))> signal_type;

        void emit(LIST(LOOP(T_arg%1 arg%1, $1), bool sync = false)) {
ifelse($1,0,[dnl
            tunnel(sigc::mem_fun(this, &signal_type::emit), sync);],[dnl
            tunnel(sigc::bind(LIST(sigc::mem_fun(this, &signal_type::emit), LOOP(arg%1, $1))), sync);])
        }

        void operator()(LIST(LOOP(T_arg%1 arg%1, $1), bool sync = false)) {
            emit(LIST(LOOP(arg%1, $1), sync));
        }
};

])

divert(0)
[/* -*- c++ -*-
 *
 *  Signal class for inter-thread communication with argument support.
 *
 *  Copyright 2004 Christer Palm <palm@nogui.se>
 *
 *  Based on GtkmmDispatcher:
 *  Copyright 2000 Andreas Rottmannn <rottmann@users.sourceforge.net>
 *  Copyright 2004 Martin Schulze <mschulze@cvs.gnome.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */]

#ifndef DISPATCHER_H_INCLUDED
#define DISPATCHER_H_INCLUDED

#include <sigc++/slot.h>
#include <sigc++/signal.h>
#include <sigc++/bind.h>
#include <sigc++/functors/mem_fun.h>
#include <glibmm/dispatcher.h>
#include <glibmm/thread.h>
#include <list>

namespace GtkUtil {

namespace internal {

class DispatcherBase
{
    private:
        struct Sync {
            Glib::Mutex mutex;
            Glib::Cond  cond;
            void wakeup() {
                Glib::Mutex::Lock lock(mutex);
                cond.signal();
            }
        };

        Glib::Thread* disp_thread;
        Glib::Dispatcher dispatch;
        Glib::Mutex queue_lock;
        std::list<sigc::slot<void> > queue;

        void push(const sigc::slot<void>& slot);
        void dispatch_self();
        void null();

    protected:
        void tunnel(const sigc::slot<void>& slot, bool sync);

    public:
        DispatcherBase();
        DispatcherBase(const Glib::RefPtr<Glib::MainContext>& context);
        ~DispatcherBase();
};

class nil;

} /* namespace internal */

DISPATCHER_N(CALL_SIZE,CALL_SIZE)
FOR(0,eval(CALL_SIZE-1),[[DISPATCHER_N(%1)]])
} /* namespace GtkUtil */

#endif /* DISPATCHER_H_INCLUDED */
